// PPgBandwidthControl.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgBandwidthControl.h"
#include "scheduler.h"

// PPgBandwidthControl dialog

IMPLEMENT_DYNAMIC(CPPgBandwidthControl, CPropertyPage)
CPPgBandwidthControl::CPPgBandwidthControl()
	: CPropertyPage(CPPgBandwidthControl::IDD)
{
}

CPPgBandwidthControl::~CPPgBandwidthControl()
{
}

void CPPgBandwidthControl::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);

	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	DDX_Control(pDX, IDC_USSMIN, m_minUpload);
	DDX_Control(pDX, IDC_USSMAX, m_maxUpload);
	DDX_Control(pDX, IDC_DSSMIN, m_minDownload);
	DDX_Control(pDX, IDC_DSSMAX, m_maxDownload);
	// Maella end
}


BEGIN_MESSAGE_MAP(CPPgBandwidthControl, CPropertyPage)
	ON_EN_CHANGE(IDC_USS_SLIDER, OnSettingsChange)
	ON_EN_CHANGE(IDC_USSMAX, OnSettingsChange)
	ON_EN_CHANGE(IDC_USSMIN, OnSettingsChange)
	ON_EN_CHANGE(IDC_DSS_SLIDER, OnSettingsChange)
	ON_EN_CHANGE(IDC_DSSMAX, OnSettingsChange)
	ON_EN_CHANGE(IDC_DSSMIN, OnSettingsChange)
	ON_BN_CLICKED(IDC_UP_AUTO, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_UP_MAXPING_TEXT, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_DOWN_AUTO, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_DOWN_MAXPING_TEXT, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_MANAGE_CONNECTIONS, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_URL_AUTO, OnSettingsChange)
	ON_BN_CLICKED(IDC_USS, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_DSS, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_ZZ_RATIO, OnSettingsChange)
	ON_BN_CLICKED(IDC_UP_MINIMIZE, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_UP_CUMULATE, OnSettingsChange)
	ON_BN_CLICKED(IDC_PROTOCOL_OVERHEAD, OnSettingsChange)
	ON_BN_CLICKED(IDC_CONNECTIONS_OVERHEAD, OnSettingsChange)
	ON_BN_CLICKED(IDC_TCP_ACK, OnSettingsChangeBox)
	ON_BN_CLICKED(IDC_BCADVANCED, OnAdvancedClicked)
	ON_BN_CLICKED(IDC_UDP_PING, OnSettingsChangeBox)
	ON_EN_CHANGE(IDC_URL_PING, OnSettingsChange)
	ON_EN_CHANGE(IDC_UP_MAXPING_INPUT, OnSettingsChange)
	ON_EN_CHANGE(IDC_DOWN_MAXPING_INPUT, OnSettingsChange)
	ON_WM_HSCROLL()

END_MESSAGE_MAP()

void CPPgBandwidthControl::LoadSettings(void)
{
	//Added by Pawcio
	char buffer[200];
	CString strBuffer;
	memset(&buffer,0,200);

	CheckDlgButton(IDC_USS,app_prefs->prefs->USSEnabled);
	CheckDlgButton(IDC_UP_AUTO,app_prefs->prefs->autoMaxUp);
	CheckDlgButton(IDC_UP_MAXPING_TEXT, app_prefs->prefs->manualUpMaxPing);
	((CSliderCtrl*)GetDlgItem(IDC_USS_SLIDER))->SetRange(1,24,true);
	((CSliderCtrl*)GetDlgItem(IDC_USS_SLIDER))->SetPos(app_prefs->prefs->USSSliderPos);

    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	strBuffer.Format("%.1f", app_prefs->prefs->minBCUpload);
	GetDlgItem(IDC_USSMIN)->SetWindowText(strBuffer);
	
	strBuffer.Format("%.1f", app_prefs->prefs->maxBCUpload);
	GetDlgItem(IDC_USSMAX)->SetWindowText(strBuffer);
	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

	CheckDlgButton(IDC_DSS,app_prefs->prefs->DSSEnabled);
	CheckDlgButton(IDC_DOWN_AUTO,app_prefs->prefs->autoMaxDown);
	CheckDlgButton(IDC_DOWN_MAXPING_TEXT, app_prefs->prefs->manualDownMaxPing);
	((CSliderCtrl*)GetDlgItem(IDC_DSS_SLIDER))->SetRange(1,24,true);
	((CSliderCtrl*)GetDlgItem(IDC_DSS_SLIDER))->SetPos(app_prefs->prefs->DSSSliderPos);

    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	strBuffer.Format("%.1f", app_prefs->prefs->minBCDownload);
	GetDlgItem(IDC_DSSMIN)->SetWindowText(strBuffer);

	strBuffer.Format("%.1f", app_prefs->prefs->maxBCDownload);
	GetDlgItem(IDC_DSSMAX)->SetWindowText(strBuffer);
	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-

	CheckDlgButton(IDC_UDP_PING, app_prefs->prefs->UDPing);
	if (app_prefs->prefs->UDPing)
		app_prefs->prefs->autoHostToPing = true;
	CheckDlgButton(IDC_URL_AUTO,app_prefs->prefs->autoHostToPing);
	CheckDlgButton(IDC_ZZ_RATIO,app_prefs->prefs->ZZRatio);
	CheckDlgButton(IDC_UP_MINIMIZE,app_prefs->prefs->minimizeOpenedSlots);
	CheckDlgButton(IDC_UP_CUMULATE,app_prefs->prefs->cumulateBandwidth);
	CheckDlgButton(IDC_PROTOCOL_OVERHEAD,app_prefs->prefs->includeOverhead);
	CheckDlgButton(IDC_CONNECTIONS_OVERHEAD,app_prefs->prefs->connectionsOverhead);
	CheckDlgButton(IDC_TCP_ACK,app_prefs->prefs->includeTCPAck);
	CheckDlgButton(IDC_MANAGE_CONNECTIONS, app_prefs->prefs->manageConnections);

	strBuffer = app_prefs->prefs->url_ping;
	strBuffer.Trim();
	GetDlgItem(IDC_URL_PING)->SetWindowText(strBuffer);

	strBuffer.Format("%d", app_prefs->prefs->base_ping_up);
	GetDlgItem(IDC_UP_MAXPING_INPUT)->SetWindowText(strBuffer);

	strBuffer.Format("%d", app_prefs->prefs->base_ping_down);
	GetDlgItem(IDC_DOWN_MAXPING_INPUT)->SetWindowText(strBuffer);
	OnSettingsChangeBox();
	SetAdvanced(false);
}
void CPPgBandwidthControl::Localize(void)
{	
	if(m_hWnd)
	{
		GetDlgItem(IDC_USS)->SetWindowText( GetResString(IDS_USS) );
		GetDlgItem(IDC_USSMAX_TEXT)->SetWindowText( GetResString(IDS_USSMAX) );
		GetDlgItem(IDC_USSMIN_TEXT)->SetWindowText( GetResString(IDS_USSMIN) );
		GetDlgItem(IDC_UP_AUTO)->SetWindowText( GetResString(IDS_UP_AUTO));
		GetDlgItem(IDC_UP_MAXPING_TEXT)->SetWindowText( GetResString(IDS_UP_MAXPING_TEXT));
		GetDlgItem(IDC_URL_PING_TEXT)->SetWindowText( GetResString(IDS_URL_PING) );
		GetDlgItem(IDC_UDP_PING)->SetWindowText( GetResString(IDS_UDP_PING));
		GetDlgItem(IDC_MANAGE_CONNECTIONS)->SetWindowText( GetResString(IDS_MANAGE_CONNECTIONS));
		GetDlgItem(IDC_ZZ_RATIO)->SetWindowText( GetResString(IDS_ZZ_RATIO) );
		GetDlgItem(IDC_UP_MINIMIZE)->SetWindowText( GetResString(IDS_UP_MINIMIZE) );
		GetDlgItem(IDC_UP_CUMULATE)->SetWindowText( GetResString(IDS_UP_CUMULATE) );
		GetDlgItem(IDC_PROTOCOL_OVERHEAD)->SetWindowText( GetResString(IDS_PROTOCOL_OVERHEAD) );
		GetDlgItem(IDC_CONNECTIONS_OVERHEAD)->SetWindowText( GetResString(IDS_CONNECTIONS_OVERHEAD) );
		GetDlgItem(IDC_TCP_ACK)->SetWindowText( GetResString(IDS_TCP_ACK) );
		GetDlgItem(IDC_LOWER_TEXT)->SetWindowText( GetResString(IDS_LOWER_TEXT));
		GetDlgItem(IDC_HIGHER_TEXT)->SetWindowText( GetResString(IDS_HIGHER_TEXT));
		GetDlgItem(IDC_MINDOWN_STATIC)->SetWindowText( GetResString(IDS_MINDOWN));
		GetDlgItem(IDC_MAXDOWN_STATIC)->SetWindowText( GetResString(IDS_MAXDOWN));
		GetDlgItem(IDC_PINGING_STATIC)->SetWindowText( GetResString(IDS_PINGING));
		GetDlgItem(IDC_BCADVANCED)->SetWindowText( GetResString(IDS_BC_ADVANCED) + (app_prefs->prefs->advancedBC ? "   ^" : "   v"));

		GetDlgItem(IDC_DSS)->SetWindowText( GetResString(IDS_DSS) );
		GetDlgItem(IDC_DSSMAX_TEXT)->SetWindowText( GetResString(IDS_DSSMAX) );
		GetDlgItem(IDC_DSSMIN_TEXT)->SetWindowText( GetResString(IDS_DSSMIN) );
		GetDlgItem(IDC_DOWN_AUTO)->SetWindowText( GetResString(IDS_UP_AUTO));
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->SetWindowText( GetResString(IDS_UP_MAXPING_TEXT));
		GetDlgItem(IDC_LOWER_TEXT2)->SetWindowText( GetResString(IDS_LOWER_TEXT2));
		GetDlgItem(IDC_HIGHER_TEXT2)->SetWindowText( GetResString(IDS_HIGHER_TEXT2));
	}
}

// PPgBandwidthControl message handlers

BOOL CPPgBandwidthControl::OnApply()
{
	char buffer[510];
	app_prefs->prefs->USSEnabled = (int8)IsDlgButtonChecked(IDC_USS);
	app_prefs->prefs->autoMaxUp = IsDlgButtonChecked(IDC_UP_AUTO);
	app_prefs->prefs->manualUpMaxPing = IsDlgButtonChecked(IDC_UP_MAXPING_TEXT);

	//Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(GetDlgItem(IDC_USSMIN)->GetWindowTextLength())
	{
		GetDlgItem(IDC_USSMIN)->GetWindowText(buffer,20);
		float upload = _tstof(buffer);
		app_prefs->prefs->minBCUpload=(upload < 1.0f ? 1.0f : upload);
	}
	if(GetDlgItem(IDC_USSMAX)->GetWindowTextLength())
	{
		GetDlgItem(IDC_USSMAX)->GetWindowText(buffer,20);
		float upload = _tstof(buffer);
		app_prefs->prefs->maxBCUpload = ((upload >= 1.0f || upload == 0.0f)? upload : 1.0f);
	}
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(app_prefs->prefs->maxBCUpload < app_prefs->prefs->minBCUpload && app_prefs->prefs->maxBCUpload != 0.0f)
		app_prefs->prefs->maxBCUpload = app_prefs->prefs->minBCUpload;

	app_prefs->prefs->DSSEnabled = (int8)IsDlgButtonChecked(IDC_DSS);
	app_prefs->prefs->autoMaxDown = IsDlgButtonChecked(IDC_DOWN_AUTO);
	app_prefs->prefs->manualDownMaxPing = IsDlgButtonChecked(IDC_DOWN_MAXPING_TEXT);

    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(GetDlgItem(IDC_DSSMIN)->GetWindowTextLength())
	{
		GetDlgItem(IDC_DSSMIN)->GetWindowText(buffer,20);
		float download = _tstof(buffer);
		app_prefs->prefs->minBCDownload=(download < 1.0f ? 1.0f : download);
	}
	if(GetDlgItem(IDC_DSSMAX)->GetWindowTextLength())
	{
		GetDlgItem(IDC_DSSMAX)->GetWindowText(buffer,20);
		float download = _tstof(buffer);
		app_prefs->prefs->maxBCDownload=((download >= 1.0f || download == 0.0f) ? download : 1.0f);
	}
    //Pawcio: BC - Maella [FAF] -Allow Bandwidth Settings in <1KB Incremements-
	if(app_prefs->prefs->maxBCDownload < app_prefs->prefs->minBCDownload && app_prefs->prefs->maxBCDownload != 0.0f)
		app_prefs->prefs->maxBCDownload = app_prefs->prefs->minBCDownload;

	app_prefs->prefs->UDPing = IsDlgButtonChecked(IDC_UDP_PING);
	if (app_prefs->prefs->UDPing)
		CheckDlgButton(IDC_URL_AUTO, TRUE);
	app_prefs->prefs->autoHostToPing = IsDlgButtonChecked(IDC_URL_AUTO);
	app_prefs->prefs->manageConnections = IsDlgButtonChecked(IDC_MANAGE_CONNECTIONS);
	app_prefs->prefs->ZZRatio = IsDlgButtonChecked(IDC_ZZ_RATIO);
	if (app_prefs->prefs->minimizeOpenedSlots != (bool)IsDlgButtonChecked(IDC_UP_MINIMIZE) ||
		app_prefs->prefs->cumulateBandwidth != (bool)IsDlgButtonChecked(IDC_UP_CUMULATE))
		theApp.uploadqueue->ResetBC();
	app_prefs->prefs->minimizeOpenedSlots = IsDlgButtonChecked(IDC_UP_MINIMIZE);
	app_prefs->prefs->cumulateBandwidth = IsDlgButtonChecked(IDC_UP_CUMULATE);
	app_prefs->prefs->includeOverhead = IsDlgButtonChecked(IDC_PROTOCOL_OVERHEAD);
	app_prefs->prefs->connectionsOverhead = IsDlgButtonChecked(IDC_CONNECTIONS_OVERHEAD);
	app_prefs->prefs->includeTCPAck = IsDlgButtonChecked(IDC_TCP_ACK);

	if (GetDlgItem(IDC_URL_PING)->GetWindowTextLength()) {
		CString strBuffer;
		GetDlgItem(IDC_URL_PING)->GetWindowText(strBuffer);
		strBuffer.Trim();
		if (strBuffer != CString(app_prefs->prefs->url_ping)){
			strcpy(app_prefs->prefs->url_ping, strBuffer.GetBuffer());
			if (!theApp.BC->SetIP(strBuffer)) {
				MessageBox("URL/IP in \"Pawcio Tweaks\" tab is not valid! Please, enter new valid one or leave blank.","Error",MB_ICONERROR|MB_OK);
			}
		}
	}
	else if (app_prefs->prefs->url_ping[0]){
		app_prefs->prefs->url_ping[0]=0;
		theApp.BC->SetIP("");
	}	

	if (GetDlgItem(IDC_UP_MAXPING_INPUT)->GetWindowTextLength()) {
		GetDlgItem(IDC_UP_MAXPING_INPUT)->GetWindowText(buffer, 20) ;
		if (atoi(buffer) < 10) {
			app_prefs->prefs->base_ping_up = 10 ;
			sprintf(buffer, "%d", app_prefs->prefs->base_ping_up);
			GetDlgItem(IDC_UP_MAXPING_INPUT)->SetWindowText(buffer) ;
		} else if (atoi(buffer) > 2500) {
			app_prefs->prefs->base_ping_up = 2500 ;
			sprintf(buffer, "%d", app_prefs->prefs->base_ping_up);
			GetDlgItem(IDC_UP_MAXPING_INPUT)->SetWindowText(buffer);
		} else {
			app_prefs->prefs->base_ping_up = (atoi(buffer) / 10) * 10; // convert to 10 multiple
			sprintf(buffer, "%d", app_prefs->prefs->base_ping_up);
			GetDlgItem(IDC_UP_MAXPING_INPUT)->SetWindowText(buffer);
		}
	}

	if (GetDlgItem(IDC_DOWN_MAXPING_INPUT)->GetWindowTextLength()) {
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->GetWindowText(buffer, 20) ;
		if (atoi(buffer) < 10) {
			app_prefs->prefs->base_ping_down = 10 ;
			sprintf(buffer, "%d", app_prefs->prefs->base_ping_down);
			GetDlgItem(IDC_DOWN_MAXPING_INPUT)->SetWindowText(buffer) ;
		} else if (atoi(buffer) > 3500) {
			app_prefs->prefs->base_ping_down = 3500 ;
			sprintf(buffer, "%d", app_prefs->prefs->base_ping_down);
			GetDlgItem(IDC_DOWN_MAXPING_INPUT)->SetWindowText(buffer);
		} else {
			app_prefs->prefs->base_ping_down = (atoi(buffer) / 10) * 10; // convert to 10 multiple
			sprintf(buffer, "%d", app_prefs->prefs->base_ping_down);
			GetDlgItem(IDC_DOWN_MAXPING_INPUT)->SetWindowText(buffer);
		}
	}
	theApp.scheduler->SaveOriginals(); // Pawcio: USS Scheduler
	UpdateBCStatus(false);
	return CPropertyPage::OnApply();
}

BOOL CPPgBandwidthControl::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	LoadSettings();
	Localize();
	UpdateBCStatus();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
void CPPgBandwidthControl::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	
	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	CString temp;
	if (pScrollBar==GetDlgItem(IDC_USS_SLIDER)) {
		app_prefs->prefs->USSSliderPos = slider->GetPos();
	}
	else if (pScrollBar==GetDlgItem(IDC_DSS_SLIDER)) {
		app_prefs->prefs->DSSSliderPos = slider->GetPos();
	}
}

afx_msg void CPPgBandwidthControl::SetBoxes(){
	if( IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_USSMIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_USSMAX)->EnableWindow(TRUE);
		GetDlgItem(IDC_UP_AUTO)->EnableWindow(TRUE);
		GetDlgItem(IDC_USS_SLIDER)->EnableWindow(TRUE);
		GetDlgItem(IDC_UP_MAXPING_TEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_UP_MAXPING_INPUT)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_USSMIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_USSMAX)->EnableWindow(FALSE);
		GetDlgItem(IDC_UP_AUTO)->EnableWindow(FALSE);
		GetDlgItem(IDC_USS_SLIDER)->EnableWindow(FALSE);
		GetDlgItem(IDC_UP_MAXPING_TEXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_UP_MAXPING_INPUT)->EnableWindow(FALSE);
	}
	if ( IsDlgButtonChecked(IDC_USS) || IsDlgButtonChecked(IDC_DSS)){
		GetDlgItem(IDC_UDP_PING)->EnableWindow(TRUE);
		GetDlgItem(IDC_URL_AUTO)->EnableWindow(TRUE);
		GetDlgItem(IDC_URL_PING)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_UDP_PING)->EnableWindow(FALSE);
		GetDlgItem(IDC_URL_AUTO)->EnableWindow(FALSE);
		GetDlgItem(IDC_URL_PING)->EnableWindow(FALSE);
	}
	if (IsDlgButtonChecked(IDC_UP_AUTO) && IsDlgButtonChecked(IDC_USS))
		GetDlgItem(IDC_USSMAX)->EnableWindow(FALSE);
	if (IsDlgButtonChecked(IDC_UP_MAXPING_TEXT)&& IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_USS_SLIDER)->EnableWindow(FALSE);
	}
	else if (IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_UP_MAXPING_INPUT)->EnableWindow(FALSE);
	}
	if (IsDlgButtonChecked(IDC_TCP_ACK) || IsDlgButtonChecked(IDC_CONNECTIONS_OVERHEAD) && !IsDlgButtonChecked(IDC_MANAGE_CONNECTIONS))
		GetDlgItem(IDC_ZZ_RATIO)->EnableWindow(FALSE);
	else
		GetDlgItem(IDC_ZZ_RATIO)->EnableWindow(TRUE);

	if( IsDlgButtonChecked(IDC_DSS)){
		GetDlgItem(IDC_DSSMIN)->EnableWindow(TRUE);
		GetDlgItem(IDC_DSSMAX)->EnableWindow(TRUE);
		GetDlgItem(IDC_DOWN_AUTO)->EnableWindow(TRUE);
		GetDlgItem(IDC_DSS_SLIDER)->EnableWindow(TRUE);
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->EnableWindow(TRUE);
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->EnableWindow(TRUE);
	}
	else{
		GetDlgItem(IDC_DSSMIN)->EnableWindow(FALSE);
		GetDlgItem(IDC_DSSMAX)->EnableWindow(FALSE);
		GetDlgItem(IDC_DOWN_AUTO)->EnableWindow(FALSE);
		GetDlgItem(IDC_DSS_SLIDER)->EnableWindow(FALSE);
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->EnableWindow(FALSE);
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->EnableWindow(FALSE);
	}
	if (IsDlgButtonChecked(IDC_DOWN_AUTO) && IsDlgButtonChecked(IDC_DSS))
		GetDlgItem(IDC_DSSMAX)->EnableWindow(FALSE);
	if (IsDlgButtonChecked(IDC_DOWN_MAXPING_TEXT)&& IsDlgButtonChecked(IDC_DSS)){
		GetDlgItem(IDC_DSS_SLIDER)->EnableWindow(FALSE);
	}
	else if (IsDlgButtonChecked(IDC_DSS)){
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->EnableWindow(FALSE);
	}
	if (IsDlgButtonChecked(IDC_UDP_PING)){
		GetDlgItem(IDC_URL_AUTO)->EnableWindow(FALSE);
	}
	else if (IsDlgButtonChecked(IDC_DSS) || IsDlgButtonChecked(IDC_USS)){
		GetDlgItem(IDC_URL_AUTO)->EnableWindow(TRUE);
	}
}

afx_msg void CPPgBandwidthControl::SetAdvanced(bool clicked){
	if (clicked) app_prefs->prefs->advancedBC = !app_prefs->prefs->advancedBC;
	GetDlgItem(IDC_BCADVANCED)->SetWindowText( GetResString(IDS_BC_ADVANCED) + (app_prefs->prefs->advancedBC ? "   ^" : "   v"));
	if (!IsDlgButtonChecked(IDC_UP_MAXPING_TEXT) && !app_prefs->prefs->advancedBC){
		GetDlgItem(IDC_UP_MAXPING_TEXT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_UP_MAXPING_INPUT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_MS_TEXT)->ShowWindow(SW_HIDE);
	}
	else{
		GetDlgItem(IDC_UP_MAXPING_TEXT)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_UP_MAXPING_INPUT)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_MS_TEXT)->ShowWindow(SW_SHOW);
	}
	if (!IsDlgButtonChecked(IDC_DOWN_MAXPING_TEXT) && !app_prefs->prefs->advancedBC){
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->ShowWindow(SW_HIDE);
		GetDlgItem(IDC_MS_TEXT2)->ShowWindow(SW_HIDE);
	}
	else{
		GetDlgItem(IDC_DOWN_MAXPING_TEXT)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_DOWN_MAXPING_INPUT)->ShowWindow(SW_SHOW);
		GetDlgItem(IDC_MS_TEXT2)->ShowWindow(SW_SHOW);
	}
	GetDlgItem(IDC_URL_PING_TEXT)->ShowWindow(app_prefs->prefs->advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_URL_PING)->ShowWindow(app_prefs->prefs->advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_UDP_PING)->ShowWindow(app_prefs->prefs->advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_URL_AUTO)->ShowWindow(app_prefs->prefs->advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_PROTOCOL_OVERHEAD)->ShowWindow(app_prefs->prefs->advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_MANAGE_CONNECTIONS)->ShowWindow(app_prefs->prefs->advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_CONNECTIONS_OVERHEAD)->ShowWindow(app_prefs->prefs->advancedBC ? SW_SHOW : SW_HIDE);
	GetDlgItem(IDC_TCP_ACK)->ShowWindow(app_prefs->prefs->advancedBC ? SW_SHOW : SW_HIDE);
}

void CPPgBandwidthControl::UpdateBCStatus(bool withSSStats){
	if(m_hWnd){
		if (theApp.glob_prefs->IsUSSEnabled() && theApp.BC->IsPingPreparing() && withSSStats)
			GetDlgItem(IDC_USS_STATUS)->SetWindowText(GetResString(IDS_SS_PREPARING));
		else if (theApp.glob_prefs->IsUSSEnabled() && theApp.BC->IsPingWorking())
			GetDlgItem(IDC_USS_STATUS)->SetWindowText(GetResString(IDS_SS_SUCCESFULL));
		else if (theApp.glob_prefs->IsUSSEnabled() && withSSStats)
			GetDlgItem(IDC_USS_STATUS)->SetWindowText(GetResString(IDS_SS_FAILED));
		else if (withSSStats || !theApp.glob_prefs->IsUSSEnabled())
			GetDlgItem(IDC_USS_STATUS)->SetWindowText(GetResString(IDS_SS_DISABLED));

		if (theApp.glob_prefs->IsDSSEnabled() && theApp.BC->IsPingPreparing() && withSSStats)
			GetDlgItem(IDC_DSS_STATUS)->SetWindowText(GetResString(IDS_SS_PREPARING));
		else if (theApp.glob_prefs->IsDSSEnabled() && theApp.BC->IsPingWorking())
			GetDlgItem(IDC_DSS_STATUS)->SetWindowText(GetResString(IDS_SS_SUCCESFULL));
		else if (theApp.glob_prefs->IsDSSEnabled() && withSSStats)
			GetDlgItem(IDC_DSS_STATUS)->SetWindowText(GetResString(IDS_SS_FAILED));
		else if (withSSStats || !theApp.glob_prefs->IsDSSEnabled())
			GetDlgItem(IDC_DSS_STATUS)->SetWindowText(GetResString(IDS_SS_DISABLED));

		if (theApp.glob_prefs->IsZZRatio() || theApp.glob_prefs->IsIncludeTCPAck() || (theApp.glob_prefs->IsConnectionsOverHead() && !theApp.glob_prefs->IsManageConnection())){
			GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(GetResString(IDS_SS_SESSION));
			CString buffer;
			if (theApp.glob_prefs->IsDSSEnabled() && (theApp.BC->IsPingWorking() || theApp.BC->IsPingPreparing())){
				if (theApp.glob_prefs->IsAutoMaxDownload())
					GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
				else{
					CString buffer;
					buffer.Format("%.1f",theApp.glob_prefs->GetMaxBCDownload());
					GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
				}
			}
			else{
				if (theApp.glob_prefs->GetMaxDownload() == UNLIMITED)
					GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
				else{
					CString buffer;
					buffer.Format("%.1f",theApp.glob_prefs->GetMaxDownload());
					GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
				}
			}
		}
		else if (theApp.glob_prefs->IsUSSEnabled() && ((theApp.BC->IsPingWorking() || theApp.BC->IsPingPreparing()))){
				CString buffer;
				if (theApp.glob_prefs->IsDSSEnabled() && (theApp.BC->IsPingWorking() || theApp.BC->IsPingPreparing())){
					float download=theApp.BC->GetMaxDownloadOnUpload(theApp.glob_prefs->GetMinBCUpload(), theApp.glob_prefs->GetMinBCDownload(), (float)(theApp.glob_prefs->IsConnectionsOverHead() && theApp.glob_prefs->IsManageConnection()));
					buffer.Format("%.1f",download);
					GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(buffer);
					if (theApp.glob_prefs->IsAutoMaxUpload())
						GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
					else {
						if (theApp.glob_prefs->IsAutoMaxDownload()){
							download = theApp.BC->GetMaxDownloadOnUpload(theApp.glob_prefs->GetMaxBCUpload(), theApp.glob_prefs->GetMinBCDownload(), (float)(theApp.glob_prefs->IsConnectionsOverHead() && theApp.glob_prefs->IsManageConnection()));
							if (download < theApp.glob_prefs->GetMinBCDownload()){
								buffer.Format("%.1f",download);
								GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
							}
							else
								GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
						}
						else {
							download = theApp.BC->GetMaxDownloadOnUpload(theApp.glob_prefs->GetMaxBCUpload(), theApp.glob_prefs->GetMaxBCDownload(), (float)(theApp.glob_prefs->IsConnectionsOverHead() && theApp.glob_prefs->IsManageConnection()));
							buffer.Format("%.1f",download);
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
						}
					}
				}
				else{
					float download=theApp.BC->GetMaxDownloadOnUpload(theApp.glob_prefs->GetMinBCUpload(), theApp.glob_prefs->GetMaxDownload(), (float)(theApp.glob_prefs->IsConnectionsOverHead() && theApp.glob_prefs->IsManageConnection()));
					if (download == UNLIMITED)
						GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
					else {
						buffer.Format("%.1f",download);
						GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(buffer);
					}
					if (theApp.glob_prefs->IsAutoMaxUpload()){
						if (download == UNLIMITED)
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
						else
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
					}
					else {
						download = theApp.BC->GetMaxDownloadOnUpload(theApp.glob_prefs->GetMaxBCUpload(), theApp.glob_prefs->GetMaxDownload(), (float)(theApp.glob_prefs->IsConnectionsOverHead() && theApp.glob_prefs->IsManageConnection()));
						if (download == UNLIMITED)
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
						else {
							buffer.Format("%.1f",download);
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
						}
					}
				}
		}
		else {
				CString buffer;
				if (theApp.glob_prefs->IsDSSEnabled() && (theApp.BC->IsPingWorking() || theApp.BC->IsPingPreparing())){
					float download=theApp.BC->GetMaxDownloadOnUpload(theApp.glob_prefs->GetMaxUpload(), theApp.glob_prefs->GetMinBCDownload(), (float)(theApp.glob_prefs->IsConnectionsOverHead() && theApp.glob_prefs->IsManageConnection()));
					buffer.Format("%.1f",download);
					GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(buffer);
					if (theApp.glob_prefs->IsAutoMaxDownload()){
						if (download < theApp.glob_prefs->GetMinBCDownload()){
							buffer.Format("%.1f",download);
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
						}
						else
							GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_AUTOLIMIT));
					}
					else {
						download = theApp.BC->GetMaxDownloadOnUpload(theApp.glob_prefs->GetMaxUpload(), theApp.glob_prefs->GetMaxBCDownload(), (float)(theApp.glob_prefs->IsConnectionsOverHead() && theApp.glob_prefs->IsManageConnection()));
						buffer.Format("%.1f",download);
						GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
					}
				}
				else {
					float download=theApp.BC->GetMaxDownloadOnUpload(theApp.glob_prefs->GetMaxUpload(), theApp.glob_prefs->GetMaxDownload(), (float)(theApp.glob_prefs->IsConnectionsOverHead() && theApp.glob_prefs->IsManageConnection()));
					if (download == UNLIMITED){
						GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
						GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(GetResString(IDS_SS_UNLIMITED));
					}
					else {
						buffer.Format("%.1f",download);
						GetDlgItem(IDC_MINDOWN_VAL)->SetWindowText(buffer);
						GetDlgItem(IDC_MAXDOWN_VAL)->SetWindowText(buffer);
					}
				}
		}
		if (theApp.glob_prefs->IsUSSEnabled() || theApp.glob_prefs->IsDSSEnabled())
			GetDlgItem(IDC_PINGING_VAL)->SetWindowText(theApp.BC->GetPingedServer());
		else
			GetDlgItem(IDC_PINGING_VAL)->SetWindowText("-");
	}
}