//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "uploadqueue.h"
#include "packets.h"
#include "emule.h"
#include "SearchDlg.h"
#include "knownfile.h"
#include "listensocket.h"
#include "ini2.h"
#include "math.h"
#include "Exceptions.h"
#include "Scheduler.h"
#include "preferencesDlg.h" //Pawcio: BC

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//Pawcio: BC

//TODO rewrite the whole networkcode, use overlapped sockets

CUploadQueue::CUploadQueue(CPreferences* in_prefs){
	app_prefs = in_prefs;
	endLoadingParts = 0;
	AfxBeginThread((AFX_THREADPROC)LoadingParts,(LPVOID) this); //Pawcio: BC
	//Pawcio: BC
	estadatarate = 2000;
	datarate = 0;
	dataratems = 0;
	datarateave = 0;
	//Pawcio: BC
	successfullupcount = 0;
	failedupcount = 0;
	totaluploadtime = 0;
	m_nUpDataRateMSOverhead = 0;
	m_nUpDatarateOverhead = 0;
	m_nUpDataOverheadSourceExchange = 0;
	m_nUpDataOverheadFileRequest = 0;
	m_nUpDataOverheadOther = 0;
	m_nUpDataOverheadServer = 0;
	m_nUpDataOverheadSourceExchangePackets = 0;
	m_nUpDataOverheadFileRequestPackets = 0;
	m_nUpDataOverheadOtherPackets = 0;
	m_nUpDataOverheadServerPackets = 0;
	m_nLastStartUpload = 0;
	//Pawcio: BC
	// By BadWolf - Accurate Speed Measurement
	sumavgUDRO = 0;
	sendperclient = 0;
	uLastAcceptNewClient = ::GetTickCount();
	sumavgdata = 0;
	m_delay = ::GetTickCount();
	m_delaytmp = 0;
	// END By BadWolf - Accurate Speed Measurement

	// Pawcio: BC
	MaxUpload=0;
	m_lastProcessTime=::GetTickCount();
	m_nLastAddToReserved=::GetTickCount();
	sumavgUDRO=0;
	feeding=0;
	priorityClient=0;
	feedingPos=0;
	reservedFeedingPos=0;
	toSend=0;
	SentToNormal=0;
	SentToReserved=0;
	reservedclientsrdy=0;
	highestScoreOnReserved=0;
	endingTransfer=0;
	bandwidthUsed=false;
	// Pawcio: BC
}

void CUploadQueue::AddUpNextClient(CUpDownClient* directadd, bool toReserve){
	POSITION toadd = 0;
	POSITION toaddPS = 0; //PowerShare
	POSITION toaddlow = 0;
	POSITION toaddlowPS = 0; //PowerShare
	uint32	bestscore = 0;
	uint32	bestscorePS = 0; //PowerShare
	uint32  bestlowscore = 0;
	uint32  bestlowscorePS = 0; //PowerShare
	CUpDownClient* newclient;
	CUpDownClient* cur_client;
	bool newAdded=false; //Pawcio: BC
	// select next client or use given client
	if (!directadd && !toReserve && reserveduploadinglist.GetCount()){
		if (reservedFeedingPos == reserveduploadinglist.GetHeadPosition())
			reservedFeedingPos = NULL;
		cur_client = reserveduploadinglist.RemoveHead();
		cur_client->ConsiderReservedTime(true);
		uploadinglist.AddTail(cur_client);
		theApp.emuledlg->transferwnd.reservedlistctrl.RemoveClient(cur_client);
		theApp.emuledlg->transferwnd.uploadlistctrl.AddClient(cur_client);
		cur_client->SetLastBlockSent();
		m_nLastStartUpload = ::GetTickCount();
		return;
	}
	if (!toReserve && theApp.glob_prefs->IsMinimizeOpenedSlots())
		return;
	CSingleLock waitinglistLock(&waitinglistMutex,true);// Pawcio: BC
	if (!directadd){
		POSITION pos1, pos2;
		// Pawcio: BC
		for (pos1 = waitinglist.GetHeadPosition();( pos2 = pos1 ) != NULL;){
			waitinglist.GetNext(pos1);
			cur_client =	waitinglist.GetAt(pos2);
			// clear dead clients
			ASSERT ( cur_client->GetLastUpRequest() );
			if ((::GetTickCount() - cur_client->GetLastUpRequest() > MAX_PURGEQUEUETIME) || !theApp.sharedfiles->GetFileByID(cur_client->GetUploadFileID()) ){
				cur_client->ClearWaitStartTime();
				RemoveFromWaitingQueue(pos2,true);	
				if (!cur_client->socket)
					cur_client->Disconnected();
				continue;
			}
			else if (cur_client->IsFriend() && cur_client->GetFriendSlot() && !cur_client->HasLowID()){
				toadd = pos2;
				break;
			}
			// finished clearing
			uint32 cur_score = cur_client->GetScore(true);
			if ( cur_score > bestscore){
				bestscore = cur_score;
				toadd = pos2;
			} else {
				cur_score = cur_client->GetScore(false);
				if ((cur_score > bestlowscore) && !cur_client->m_bAddNextConnect){
					bestlowscore = cur_score;
					toaddlow = pos2;
				}
			}
			//PowerShare
			if (cur_client->GetPowerShared()){
				cur_score = cur_client->GetScore(true);
				if ( cur_score > bestscorePS){
					bestscorePS = cur_score;
					toaddPS = pos2;
				} else {
					cur_score = cur_client->GetScore(false);
					if ((cur_score > bestlowscorePS) && !cur_client->m_bAddNextConnect){
						bestlowscorePS = cur_score;
						toaddlowPS = pos2;
					}
				}
			}
			//PowerShare
		}

		//PowerShare
		if (bestlowscorePS > bestscorePS){
			newclient = waitinglist.GetAt(toaddlowPS);
			newclient->m_bAddNextConnect = true;
		}
		else if (!bestscorePS && bestlowscore > bestscore){
			newclient = waitinglist.GetAt(toaddlow);
			newclient->m_bAddNextConnect = true;
		}
		if (!toaddPS && !toadd)
			return;
		theApp.m_edt.AddWaitingPeriod(); //<<-- enkeyDev(th1) -EDT-
		if (toReserve)
			m_nLastAddToReserved = ::GetTickCount();
		else
			m_nLastStartUpload = ::GetTickCount();

		newclient = waitinglist.GetAt((toaddPS ? toaddPS : toadd));

		//Pawcio: BC
		lastupslotHighID = true; // VQB LowID alternate
		//AddLogLine(true,"Added High ID: %s", newclient->GetUserName()); // VQB:  perhaps only add to debug log?

		RemoveFromWaitingQueue((toaddPS ? toaddPS : toadd), true);
		theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
		newAdded=true;	//Pawcio
	}
	else {
		newclient = directadd;
		newAdded=true;	//Pawcio
		/*if (!IsDownloading(newclient)){
            if (newclient->HasLowID())
                AddLogLine(true,"DirectAdd:  LowID: %s", newclient->GetUserName());
			else
                AddLogLine(true,"DirectAdd:  HighID: %s", newclient->GetUserName());
		}*/
	}

	if (IsDownloading(newclient)){
		return;
	}
	// tell the client that we are now ready to upload
	if (!newclient->socket || !newclient->socket->IsConnected()){
		newclient->SetUploadState(US_CONNECTING);
		if (!newclient->TryToConnect(true))
			return;
		else if (!newclient->socket)
			return;
	}
	else{
		//Pawcio: Parts Selector
		CKnownFile* reqfile = theApp.sharedfiles->GetFileByID(newclient->GetUploadFileID());
		if (reqfile){
			CSafeMemFile data(16+16);
			data.Write(reqfile->GetFileHash(),16);
			if (reqfile->IsPartFile())
				((CPartFile*)reqfile)->WritePartStatus(&data, newclient, true);	// SLUGFILLER: hideOS
			else if (!reqfile->HideOvershares(&data, newclient, true)){	// SLUGFILLER: hideOS
				uint32 null = 0;
				data.Write(&null,3);
			}
			Packet* packet = new Packet(&data);
			packet->opcode = OP_FILESTATUS;
			theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
			newclient->socket->SendPacket(packet,true);
		}
		//Pawcio: Parts Selector
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		newclient->socket->SendPacket(packet,true);
		newclient->SetUploadState(US_UPLOADING);
	}
	newclient->SetUpStartTime();
	newclient->ResetSessionUp();
	newclient->ResetProcessRate(); // Pawcio: BC

	// Pawcio: BC
	if (toReserve)
		reserveduploadinglist.AddTail(newclient);
	else
	uploadinglist.AddTail(newclient);
	
	prioritylist.AddTail(newclient);
	if (newclient->socket) newclient->socket->SetPriorityReceive(true);
	//theApp.emuledlg->AddLogLine(false, "Adding: %s", newclient->GetUserName());
	
	// statistic
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)newclient->GetUploadFileID());
	if (reqfile && newAdded) //Pawcio: BC
		reqfile->statistic.AddAccepted();
		
	if (toReserve)
		theApp.emuledlg->transferwnd.reservedlistctrl.AddClient(newclient);
	else
		theApp.emuledlg->transferwnd.uploadlistctrl.AddClient(newclient);	// Pawcio: BC
}

//Pawcio: BC
void CUploadQueue::ProcessSending() {
	if (avarage_dr_list.GetCount()>0) {
		// By BadWolf - Accurate speed Measurement
		while ((float)(avarage_dr_list.GetTail().timestamp - avarage_dr_list.GetHead().timestamp)  > MAXAVERAGETIME)
		dataratems-=avarage_dr_list.RemoveHead().datalen;
		uint32 tick_avg = 50;
		if (avarage_dr_list.GetCount() >10) {
		uint32 deltat=(avarage_dr_list.GetTail().timestamp - avarage_dr_list.GetHead().timestamp);
			if (deltat>0) datarate = (1000i64*dataratems) / deltat;
		tick_avg = deltat / avarage_dr_list.GetCount();
	} else
		datarate = 0;
	}
	else
		datarate = 0;

	uint32 datarateX;
	// Pawcio: BC
	if (sentToNormalList.GetCount()>0) {
		while (sentToNormalList.GetTail().timestamp - sentToNormalList.GetHead().timestamp  > MAXAVERAGETIME/2)
			DataSentToNormal -= sentToNormalList.RemoveHead().datalen;
	}
	else
		DataSentToNormal = 0;

	if (sentToReservedList.GetCount()>0) {
		while (sentToReservedList.GetTail().timestamp - sentToReservedList.GetHead().timestamp  > MAXAVERAGETIME/2)
			DataSentToReserved -= sentToReservedList.RemoveHead().datalen;
	}
	else
		DataSentToReserved = 0;

	datarateX=0;
	SentToNormal=0;
	SentToReserved=0;

	uint32 deltaTime = ::GetTickCount() - m_lastProcessTime;
	m_lastProcessTime += deltaTime;
	if (deltaTime>350) deltaTime=350;
	else if (deltaTime<10) deltaTime=10;
	float normalization=(float)deltaTime/50.0f;

	float currMaxUpload = theApp.BC->GetMaxUpload();
	if (currMaxUpload == UNLIMITED)
		MaxUpload = theApp.glob_prefs->GetMaxGraphUploadRate() * 820.0f;
	else
		MaxUpload = currMaxUpload * 1024.0f;

	uint32 sendPerTick=MaxUpload*normalization/20;

	toSend+=sendPerTick;
	if (toSend > (int) 2*MAXFRAGSIZE && toSend > (int) MaxUpload/3){
		if (MaxUpload/3 < MAXFRAGSIZE)
			toSend=MAXFRAGSIZE;
		else
			toSend=MaxUpload/3;
	}

	POSITION pos=NULL;
	POSITION prev_pos=NULL;
	CUpDownClient* cur_client=NULL;
	CEMSocket* cur_socket=NULL;
	uint32 packetSize;

    //When upload limit is too low don't allow 
	//overhead (control packets) eats the whole bandwidth
	bool prioritySend = false;
	//Serve blocked sockets
	pos=blockedSockets.GetHeadPosition();
	while (pos && toSend > 0){
		prev_pos=pos;
		cur_socket=blockedSockets.GetNext(pos);
		//if (!cur_socket->IsBusy())
		//	ASSERT(false);
		if (cur_socket->IsRemoveFromBlockedQueue()){
			cur_socket->SetOnBlockedControlQueue(false);
			cur_socket->SetRemoveFromBlockedQueue(false);
			blockedSockets.RemoveAt(prev_pos);
			continue;
		}
		if (/*!cur_socket->IsBlocked() && */cur_socket->IsConnected()){
			packetSize=cur_socket->GetBlockedDataSize();
			if (toSend > (int)packetSize){
				cur_socket->Send(0,0);
				if (!cur_socket->IsBusy()){
					cur_socket->SetOnBlockedControlQueue(false);
					cur_socket->SetRemoveFromBlockedQueue(false);
					blockedSockets.RemoveAt(prev_pos);
				}
			}
			else if (!cur_socket->IsBlocked()){
				if (packetSize > MAXFRAGSIZE || !packetSize){
					cur_socket->SetOnBlockedControlQueue(false);
					cur_socket->SetRemoveFromBlockedQueue(false);
					blockedSockets.RemoveAt(prev_pos);
				}
				else prioritySend=true;
			}
		}
	}

	//Don't allow user to be removed from upload queue when there is to low bandwidth
	clientsrdy = 0;
	pos=uploadinglist.GetHeadPosition();
	cur_client=NULL;
	prev_pos=NULL;
	CUpDownClient* prev_client=NULL;
	endingTransfer=0;
	while (pos){
		cur_client = uploadinglist.GetAt(pos);
		cur_client->processed=0;
		if (cur_client->IsToBeRemoved()){
			uploadinglist.GetNext(pos);
			RemoveFromUploadQueue(cur_client);
			if (cur_client->toDelete) delete cur_client;
			continue;
		}
		if (cur_client->isReadyToSendFileData()){
			packetSize=cur_client->GetPacketSizeToSend();
			if (cur_client->GetTimeSinceLastKeepAliveSent() > (uint32) MAXFRAGSIZE*2){
				if (toSend> (int)packetSize){
					cur_client->SendBlockData(packetSize, true);
					datarateX+=packetSize;
					cur_client->processed=1;
				}
				else
					prioritySend=true;
			}
			if (prev_client && prev_client != priorityClient && prev_client->GetAvgRatio() < cur_client->GetAvgRatio() && theApp.glob_prefs->IsCumulateBandwidth()){
				uploadinglist.RemoveAt(pos);
				uploadinglist.InsertBefore(prev_pos, cur_client);
				pos=prev_pos;
			}
			cur_client->m_uBusyTicks = 0;
		}
		else {
			cur_client->m_uReadyTicks = 0;
			cur_client->m_uBusyTicks++;
			cur_client->CalcRatio(true);
			if (cur_client->isReady() && cur_client->socket->IsConnected() && cur_client->socket->HasControlPacket())
				cur_client->socket->SetPrioritySend();
		}
		if (cur_client->isReady() && cur_client->hasBlock())
			clientsrdy++;
		if (cur_client->IsRequest() && !cur_client->waitingforparts && !cur_client->IsSetToRemove()){
			cur_client->waitingforparts=true;
			cur_client->noBlocksToSend=false;
			CSingleLock withoutpartlock(&withoutpartMutex, true);//Pawcio: BC
			withoutpart.AddTail(cur_client);
		}
		if (cur_client->IsSetToRemove() || cur_client->noBlocksToSend)
			endingTransfer++;
		if (pos != prev_pos){
		prev_pos=pos;
		prev_client=cur_client;
		}
		uploadinglist.GetNext(pos);
	}

	reservedclientsrdy=0;
	pos=reserveduploadinglist.GetHeadPosition();
	prev_pos=NULL;
	prev_client=NULL;
	uint32 score=0;
	while (pos){
		cur_client = reserveduploadinglist.GetAt(pos);
		cur_client->processed=0;
		if (cur_client->IsToBeRemoved()){
			reserveduploadinglist.GetNext(pos);
			RemoveFromReservedQueue(cur_client);
			if (cur_client->toDelete) delete cur_client;
			continue;
		}
		if (cur_client->GetScore(true, false) > score)
			score=cur_client->GetScore(true, false);
		if (cur_client->isReadyToSendFileData()){
			packetSize=cur_client->GetPacketSizeToSend();
			if (cur_client->GetTimeSinceLastKeepAliveSent() > (uint32) MAXFRAGSIZE*2){
				if (toSend > (int)packetSize){
					cur_client->ConsiderReservedTime();
					cur_client->SendBlockData(packetSize, true);
					datarateX+=packetSize;
					cur_client->processed=1;
				}
				else
					prioritySend=true;
			}
			if (prev_client && prev_client->GetAvgRatio() < cur_client->GetAvgRatio() && theApp.glob_prefs->IsCumulateBandwidth()){
				reserveduploadinglist.RemoveAt(pos);
				reserveduploadinglist.InsertBefore(prev_pos, cur_client);
				pos=prev_pos;
			}
			cur_client->m_uBusyTicks = 0;
		}
		else {
			cur_client->m_uReadyTicks = 0;
			cur_client->m_uBusyTicks++;
			cur_client->CalcRatio(true);
			if (cur_client->isReady() && cur_client->socket->IsConnected() && cur_client->socket->HasControlPacket())
				cur_client->socket->SetPrioritySend();
		}
		if (cur_client->IsRequest() && !cur_client->waitingforparts && !cur_client->IsSetToRemove()){
			cur_client->waitingforparts=true;
			cur_client->noBlocksToSend=false;
			CSingleLock withoutpartlock(&withoutpartMutex, true);//Pawcio: BC
			withoutpart.AddTail(cur_client);
		}
		if (cur_client->isReady() && (cur_client->hasBlock() /*|| cur_client->waitingforparts*/))
			reservedclientsrdy++;
		if (pos != prev_pos){
		prev_pos=pos;
		prev_client=cur_client;
		}
		reserveduploadinglist.GetNext(pos);
	}
	highestScoreOnReserved=score;

	//Serve control packets
	pos=EMSockControlQueue.GetHeadPosition();
	while (pos && toSend > 0){
		prev_pos=pos;
		cur_socket=EMSockControlQueue.GetNext(pos);
		//if (!cur_socket->HasControlPacket())
		//	ASSERT(false);
		if (cur_socket->IsRemoveFromUpControl()){
			cur_socket->SetOnUpControlQueue(false);
			cur_socket->SetRemoveFromUpControl(false);
			EMSockControlQueue.RemoveAt(prev_pos);
			continue;
		}
		if (!prioritySend || !theApp.glob_prefs->IsIncludeOverhead() || cur_socket->IsPrioritySend()){
			packetSize=cur_socket->GetControlPacketSizeToSend();
			while (!cur_socket->IsBusy() && cur_socket->IsConnected() && (toSend > (int)packetSize || cur_socket->IsPrioritySend() || !theApp.glob_prefs->IsIncludeOverhead())){
				cur_socket->SendControlPacket(packetSize);
				if (!cur_socket->HasControlPacket()){
					cur_socket->SetOnUpControlQueue(false);
					cur_socket->SetRemoveFromUpControl(false);
					EMSockControlQueue.RemoveAt(prev_pos);
					break;
				}
				packetSize=cur_socket->GetControlPacketSizeToSend();
			}
		}
	}

	//Check the need to add new client to reserved queue or upload queue
	if (AcceptToReserved())
		AddUpNextClient(0, true);
	else if (AcceptNewClient())
		AddUpNextClient();
	if (!uploadinglist.GetCount()) {
		TransferredData newitem = {datarateX, ::GetTickCount()};  // theApp.stat_sessionSentBytes
		avarage_dr_list.AddTail(newitem);
		dataratems+=datarateX;
		bandwidthUsed = false;
		return;
	}
	//End check

	if (theApp.glob_prefs->IsCumulateBandwidth()){
		if (!priorityClient && prioritylist.GetCount()){
			priorityClient=(CUpDownClient*) prioritylist.RemoveHead();
			if (pos = uploadinglist.Find(priorityClient)){
				uploadinglist.RemoveAt(pos);
				uploadinglist.AddHead(priorityClient);
			}
			else if (pos=reserveduploadinglist.Find(priorityClient)){
					priorityClient->ConsiderReservedTime(true);
					uploadinglist.AddHead(priorityClient);
					reserveduploadinglist.RemoveAt(pos);
					theApp.emuledlg->transferwnd.reservedlistctrl.RemoveClient(priorityClient);
					theApp.emuledlg->transferwnd.uploadlistctrl.AddClient(priorityClient);
					m_nLastStartUpload = ::GetTickCount();
					priorityClient->SetLastBlockSent();
				}
				else{
					priorityClient=0;
					theApp.emuledlg->AddDebugLogLine(false,"Error in handling slots.");
				}
			}

		bandwidthUsed=(prioritySend)?true:false;/*true;*/

		pos=uploadinglist.GetHeadPosition();
		while (pos){
			prev_pos=pos;
			cur_client = uploadinglist.GetNext(pos);
			if (!bandwidthUsed && cur_client->isReadyToSendFileData()){
				//if (!cur_client->m_uTransferTicks && cur_client->m_uReadyTicks)
				//		cur_client->CalcRatio();
				packetSize=cur_client->GetPacketSizeToSend();
				while (toSend > (int)packetSize && cur_client->isReadyToSendFileData() && !prioritySend){
					cur_client->m_uReadyTicks++;
					cur_client->SendBlockData(packetSize);
					datarateX+=packetSize;
					SentToNormal+=packetSize;
					cur_client->processed=1;
					packetSize=cur_client->GetPacketSizeToSend();
				}
				if (toSend > (int) packetSize && !prioritySend)
					bandwidthUsed=false;
				else
					bandwidthUsed=true;
			}
			if (!cur_client->processed){
				cur_client->SendBlockData(0);
				cur_client->processed=1;
			}
			if (cur_client->GetTimeSinceLastSent() > 20000 && cur_client!=priorityClient && uploadinglist.GetCount() > 1){
				uploadinglist.RemoveAt(prev_pos);
				cur_client->SetTimeOnReserved();
				reserveduploadinglist.AddHead(cur_client);
				theApp.emuledlg->transferwnd.reservedlistctrl.AddClient(cur_client);
				theApp.emuledlg->transferwnd.uploadlistctrl.RemoveClient(cur_client);
			}
		}

		pos=reserveduploadinglist.GetHeadPosition();
		while (pos){
			cur_client = reserveduploadinglist.GetNext(pos);
			packetSize=cur_client->GetPacketSizeToSend();
			if (!bandwidthUsed && cur_client->isReadyToSendFileData()) {
				while (!prioritySend && toSend > (int)packetSize && cur_client->isReadyToSendFileData()){
					cur_client->m_uReadyTicks++;
				cur_client->ConsiderReservedTime();
				cur_client->SendBlockData(packetSize);
				datarateX+=packetSize;
				SentToReserved+=packetSize;
				cur_client->processed=1;
				packetSize=cur_client->GetPacketSizeToSend();
			}
				if (toSend > (int) packetSize && !prioritySend)
					bandwidthUsed=false;
				else
					bandwidthUsed=true;
			}
			if (!cur_client->processed){
				cur_client->ConsiderReservedTime();
				cur_client->SendBlockData(0);
				cur_client->processed=1;
			}
		}
	}
	else{
		pos=feedingPos;
		uint32 notFullFeeded=uploadinglist.GetCount();
		if (prioritySend)
			bandwidthUsed=true;
		else
			bandwidthUsed=false;
		while (notFullFeeded){
			if (!pos) pos=uploadinglist.GetHeadPosition();
			cur_client = uploadinglist.GetNext(pos);
			packetSize=cur_client->GetPacketSizeToSend();
			if (toSend > (int) packetSize && cur_client->isReadyToSendFileData() && !prioritySend){
				cur_client->m_uReadyTicks++;
				cur_client->SendBlockData(packetSize);
				datarateX+=packetSize;
				SentToNormal+=packetSize;
				cur_client->processed=1;
			}
			else if (!cur_client->processed){
				cur_client->SendBlockData(0);
				cur_client->processed=2;
				notFullFeeded--;
			}
			else if (cur_client->processed == 1){
				cur_client->processed=2;
				notFullFeeded--;
			}
			if (toSend < (int) packetSize)
				bandwidthUsed=true;
		}
		feedingPos=pos;

		pos=reservedFeedingPos;
		notFullFeeded=reserveduploadinglist.GetCount();
		while (notFullFeeded){
			if (!pos) pos=reserveduploadinglist.GetHeadPosition();
			cur_client = reserveduploadinglist.GetNext(pos);
			packetSize=cur_client->GetPacketSizeToSend();
			if (!bandwidthUsed  && !prioritySend && toSend > (int) packetSize && cur_client->isReadyToSendFileData()){
				cur_client->m_uReadyTicks++;
				cur_client->ConsiderReservedTime();
				cur_client->SendBlockData(packetSize);
				datarateX+=packetSize;
				SentToReserved+=packetSize;
				cur_client->processed=1;
			}
			else if (!cur_client->processed){
				cur_client->ConsiderReservedTime();
				cur_client->SendBlockData(0);
				cur_client->processed=2;
				notFullFeeded--;
			}
			else if (cur_client->processed == 1){
				cur_client->processed=2;
				notFullFeeded--;
			}
			if (toSend < (int) packetSize)
				bandwidthUsed=true;
		}
		reservedFeedingPos=pos;
	}
	TransferredData transferitem = {SentToNormal, ::GetTickCount()};
	sentToNormalList.AddTail(transferitem);
	DataSentToNormal+=SentToNormal;

	transferitem.datalen=SentToReserved;
	transferitem.timestamp=::GetTickCount();
	sentToReservedList.AddTail(transferitem);
	DataSentToReserved+=SentToReserved;

	//Pawcio: BC
	TransferredData newitem = {datarateX, ::GetTickCount()};  // theApp.stat_sessionSentBytes
	avarage_dr_list.AddTail(newitem);
	dataratems+=datarateX;
};

//Pawcio: BC
bool CUploadQueue::AcceptToReserved(bool lowID){
	if (!uploadinglist.GetCount() && !reserveduploadinglist.GetCount())
		return true;
	if (::GetTickCount() - m_nLastAddToReserved < 5000)
		return false;
	if (theApp.glob_prefs->IsMinimizeOpenedSlots() && (!bandwidthUsed || endingTransfer || lowID)){
		uint16 openedSlots = uploadinglist.GetCount() + reserveduploadinglist.GetCount();
		if (openedSlots > MaxSlots(lowID))
			return false;
		uint16 nMaxSlots = SlotsInRange(lowID);
		if (!nMaxSlots){
			if (!clientsrdy && !reservedclientsrdy && (openedSlots < MaxUpload / (2500 + datarate/250) + 1) && openedSlots <= MaxSlots() && theApp.BC->GetCurrPing() <= 0.9f * theApp.BC->GetBasePingUp())
				return true;
			return false;
		}
		if (lowID)
			return true;
		if (endingTransfer && openedSlots < 3)
			return true;
		if (theApp.BC->GetCurrPing() > theApp.BC->GetBasePingUp() && !theApp.BC->IsMinUpReached())
			return false;
		uint16 nMaxReadySlots = 2;
		if (openedSlots >= nMaxSlots/2)
			nMaxReadySlots = 1;
		if (clientsrdy + reservedclientsrdy < nMaxReadySlots + endingTransfer)
			return true;
	}
	else if (!theApp.glob_prefs->IsMinimizeOpenedSlots()){
		if (reserveduploadinglist.GetCount() < endingTransfer || !reserveduploadinglist.GetCount() && !clientsrdy)
			return true;
		if (theApp.glob_prefs->IsCumulateBandwidth())
			return AcceptToUpload(true);
	}
	return false;
}
bool CUploadQueue::AcceptNewClient(){
	// check if we can allow a new client to start downloading form us
	//Pawcio: BC
	if (theApp.glob_prefs->IsMinimizeOpenedSlots() || theApp.glob_prefs->IsCumulateBandwidth()){
		if (!uploadinglist.GetCount())
			return true;
		if (::GetTickCount() - m_nLastStartUpload < 5000)
			return false;
		if (!theApp.glob_prefs->IsMinimizeOpenedSlots() && !AcceptToUpload())
			return false;
		/*if (!clientsrdy && !reservedclientsrdy && SlotsInRange())
			return true;*/
		if ( DataSentToReserved*10 > DataSentToNormal && DataSentToReserved > 5000 ||
			DataSentToReserved > 50000 || DataSentToReserved*3 > DataSentToNormal ){
				DataSentToReserved=0;
				sentToReservedList.RemoveAll();
				return true;
		}
	}
	else
		return AcceptToUpload();
	//nope
	return false;
}

bool CUploadQueue::AcceptToUpload(bool countReserved){ //Pawcio: BC
	if (::GetTickCount() - m_nLastStartUpload < 1000 && datarate < 102400 )
		return false;
	uint32 curUploadSlots = (uint32)uploadinglist.GetCount() + (countReserved ? reserveduploadinglist.GetCount() : 0);
	if (curUploadSlots < MIN_UP_CLIENTS_ALLOWED)
		return true;
	else if (curUploadSlots >= MAX_UP_CLIENTS_ALLOWED)
		return false;

	uint32	upPerClient = UPLOAD_CLIENT_DATARATE + datarate/250;
	if( upPerClient > 4000 )
		upPerClient = 4000;

	//now the final check
	if (!theApp.BC->IsPingWorking() && !theApp.BC->IsPingPreparing() && theApp.glob_prefs->GetMaxUpload() == UNLIMITED){
		uint32 maxCurrRate = (uint32)theApp.BC->GetMaxDataRate() * 1024;
		if (curUploadSlots < ((maxCurrRate/upPerClient)+2) && curUploadSlots < ((datarate * 2/upPerClient)+2))
			return true;
	}
	else{
		uint16 nMaxSlots = 0;
		if (MaxUpload > 10240){
			nMaxSlots += 2;
				nMaxSlots += (uint16)ceil((float)(MaxUpload - 10240) / upPerClient);
		}
		else
			nMaxSlots = MIN_UP_CLIENTS_ALLOWED;
//AddLogLine(true,"maxslots=%u, upPerClient=%u",nMaxSlots,upPerClient);
			if (curUploadSlots < (datarate/UPLOAD_CHECK_CLIENT_DR) && curUploadSlots < nMaxSlots )
			return true;
	}
	//Pawcio: BC
	return false;
}

CUploadQueue::~CUploadQueue(){
}

void CUploadQueue::WaitForLoadingParts(){
	//Pawcio: BC
	if (endLoadingParts){ //Pawcio: BC
		endLoadingParts->Lock();
		delete endLoadingParts;
	}
}

CUpDownClient* CUploadQueue::GetWaitingClientByIP_UDP(uint32 dwIP, uint16 nUDPPort){
	CSingleLock waitinglistLock(&waitinglistMutex, true);//Pawcio: BC
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;){
		CUpDownClient* cur_client = waitinglist.GetNext(pos);
		if (dwIP == cur_client->GetIP() && nUDPPort == cur_client->GetUDPPort())
			return cur_client;
	}
	return 0;
}

#ifdef _DEBUG
CUpDownClient* CUploadQueue::GetWaitingClientByIP(uint32 dwIP){
	CSingleLock waitinglistLock(&waitinglistMutex, true);//Pawcio: BC
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;){
		CUpDownClient* cur_client = waitinglist.GetNext(pos);
		if (dwIP == cur_client->GetIP())
			return cur_client;
	}
	return 0;
}
#endif

/*void CUploadQueue::UpdateBanCount(){
	int count=0;
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* cur_client= waitinglist.GetAt(pos);
		if(cur_client->IsBanned())
			count++;
	}
	SetBanCount(count);
}*/

void CUploadQueue::AddClientToQueue(CUpDownClient* client, bool bIgnoreTimelimit){
	//Xman fix: only do something if reqfile
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)client->GetUploadFileID());
	if (!reqfile){
		theApp.emuledlg->AddDebugLogLine(false,"Client %s is asking for a unknwon file",client->GetUserName());
		return;
	}
	if (theApp.serverconnect->IsConnected() && theApp.serverconnect->IsLowID()
		&& !theApp.serverconnect->IsLocalServer(client->GetServerIP(),client->GetServerPort())
		&& client->GetDownloadState() == DS_NONE && !client->IsFriend()
		&& GetWaitingUserCount() > 50)
		return;
	client->AddAskedCount();
	client->SetLastUpRequest();
	if (!bIgnoreTimelimit){
		client->AddRequestCount(client->GetUploadFileID());
	}
	if ( client->IsBanned() )
		return;
	uint16 cSameIP = 0;
	// check for double
	POSITION pos1, pos2;
	CSingleLock waitinglistLock(&waitinglistMutex, true);
	for (pos1 = waitinglist.GetHeadPosition();( pos2 = pos1 ) != NULL;){
		waitinglist.GetNext(pos1);
		CUpDownClient* cur_client= waitinglist.GetAt(pos2);
		if (cur_client == client){	//already on queue
			//Xman see OnUploadqueue
			//look if the client is now asking for another file
			CKnownFile* newreqfile = theApp.sharedfiles->GetFileByID((uchar*)client->GetUploadFileID());
			CKnownFile* oldreqfile = theApp.sharedfiles->GetFileByID((uchar*)client->GetOldUploadFileID());
			if(newreqfile != oldreqfile)
			{
				if (oldreqfile) 
					oldreqfile->statistic.RemoveOnUploadqueue();
				if (newreqfile) {
					newreqfile->statistic.AddOnUploadqueue();
				        client->SetOldUploadFileID();
					newreqfile->statistic.AddRequest(); //Xman Bugfix of official client: official client doesn't count a request when a user swapped to other file
				}
				client->SetOldUploadFileID();
			}
			//Xman end
			// VQB LowID Slot Patch -- note:  should add limit so only if #slots < UL -or- UL+1 for Low UL (?)
			// Pawcio: BC LowID to Reserved
			if (client->m_bAddNextConnect && lastupslotHighID){
				if (theApp.glob_prefs->IsMinimizeOpenedSlots() && AcceptToReserved(true)
					|| !theApp.glob_prefs->IsMinimizeOpenedSlots() && (uint32)uploadinglist.GetCount()<<10 < MaxUpload) {
						RemoveFromWaitingQueue(pos2,true);
						client->m_bAddNextConnect = false;
						AddUpNextClient(client, true);
						lastupslotHighID = false; // LowID alternate
						return;
					}
			}
			// VQB end
			// Pawcio: BC
			client->SendRankingInfo();
			theApp.emuledlg->transferwnd.queuelistctrl.RefreshClient(client);
			return;			
		}
		else if ( client->Compare(cur_client) ) {
			theApp.clientlist->AddTrackClient(client); // in any case keep track of this client

			// another client with same ip:port or hash
			// this happens only in rare cases, because same userhash / ip:ports are assigned to the right client on connecting in most cases
			if (cur_client->credits != NULL && cur_client->credits->GetCurrentIdentState(cur_client->GetIP()) == IS_IDENTIFIED){
				//cur_client has a valid secure hash, don't remove him
				AddDebugLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),client->GetUserName() );
				return;
			}
			if (client->credits != NULL && client->credits->GetCurrentIdentState(client->GetIP()) == IS_IDENTIFIED){
				//client has a valid secure hash, add him remove other one
				theApp.emuledlg->AddDebugLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),cur_client->GetUserName() );//Pawcio Fix
				RemoveFromWaitingQueue(pos2,true);	
				if (!cur_client->socket)
					cur_client->Disconnected();
			}
			else{
				// remove both since we dont know who the bad on is
				AddDebugLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),"Both" );
				RemoveFromWaitingQueue(pos2,true);	
				if (!cur_client->socket)
					cur_client->Disconnected();	
				return;
			}
		}
		else if (client->GetIP() == cur_client->GetIP()){
			// same IP, different port, different userhash
			cSameIP++;
		}
	}
	if (cSameIP >= 3){
		// do not accept more than 3 clients from the same IP
		DEBUG_ONLY(AddDebugLogLine(false,"%s's (%s) request to enter the queue was rejected, because of too many clients with the same IP",client->GetUserName(), client->GetFullIP() ));
		return;
	}
	else if (theApp.clientlist->GetClientsFromIP(client->GetIP()) >= 3){
		DEBUG_ONLY(AddDebugLogLine(false,"%s's (%s) request to enter the queue was rejected, because of too many clients with the same IP (found in TrackedClientsList)",client->GetUserName(), client->GetFullIP() ));
		return;
	}
	// done

	// Add clients server to list.
	if (theApp.glob_prefs->AddServersFromClient() && client->GetServerIP() && client->GetServerPort()){
		in_addr host;
		host.S_un.S_addr = client->GetServerIP();
		CServer* srv = new CServer(client->GetServerPort(), inet_ntoa(host));
		srv->SetListName(srv->GetAddress());

		if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(srv, true))
			delete srv;
	}

	// statistic values
	reqfile->statistic.AddRequest();
	// TODO find better ways to cap the list
	uint32 size=waitinglist.GetCount();
	//Pawcio: Waiting Queue Overflow
	if (size > theApp.glob_prefs->GetQueueSize() && !theApp.glob_prefs->IsInfiniteQueueEnabled())
		//Xman Queueoverflow Minimumcontingent
	{
		if(!theApp.glob_prefs->IsWQueueOverflow())
			return;
		else
		{
			uint16 shared = theApp.sharedfiles->GetCount();
			if (shared){//Should never happens, but incase
				uint16 mincontingent=(theApp.glob_prefs->GetQueueSize()/shared/2);
				if (reqfile->statistic.GetOnUploadqueue()> mincontingent)
					return;
			}
			else
				return;
		}

	}
	//Xman end Queueoverflow Minimumcontingent
	if (client->IsDownloading()){
		// he's already downloading and wants probably only another file
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		client->socket->SendPacket(packet,true);
		return;
	}
	// Pawcio: BC
	waitinglist.AddTail(client);
	client->SetUploadState(US_ONUPLOADQUEUE);
	theApp.emuledlg->transferwnd.queuelistctrl.AddClient(client,true);
	theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
	client->SendRankingInfo();
	//Xman see OnUploadqueue
	reqfile->statistic.AddOnUploadqueue(); //Do this only if reqfile!!! (is asked above)	
	client->SetOldUploadFileID();
	//Xman end
	//}
}

bool CUploadQueue::RemoveFromUploadQueue(CUpDownClient* client, bool updatewindow){
	theApp.clientlist->AddTrackClient(client); // Keep track of this client
	for (POSITION pos = uploadinglist.GetHeadPosition();pos != 0;uploadinglist.GetNext(pos)){
		if (client == uploadinglist.GetAt(pos)){
			//Pawcio: Parts Selector
			if (client->socket){
				CKnownFile* reqfile = theApp.sharedfiles->GetFileByID(client->GetUploadFileID());
				if (reqfile){
					CSafeMemFile data(16+16);
					data.Write(reqfile->GetFileHash(),16);
					if (reqfile->IsPartFile())
						((CPartFile*)reqfile)->WritePartStatus(&data, 0);	// SLUGFILLER: hideOS
					else if (!reqfile->HideOvershares(&data, 0)){	// SLUGFILLER: hideOS
						uint32 null = 0;
						data.Write(&null,3);
					}
					Packet* packet = new Packet(&data);
					packet->opcode = OP_FILESTATUS;
					theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
					client->socket->SendPacket(packet,true);
				}
			}
			//Pawcio: Parts Selector

            //Pawcio: BC
			if (client == feeding)
				feeding=NULL;
			if (client == priorityClient)
				priorityClient=NULL;
			if (feedingPos == pos){
				POSITION next=pos;
				uploadinglist.GetNext(next);
				feedingPos=next;
			}
			if (updatewindow)
				theApp.emuledlg->transferwnd.uploadlistctrl.RemoveClient(uploadinglist.GetAt(pos));
			uploadinglist.RemoveAt(pos);
			if (pos=prioritylist.Find(client))
				prioritylist.RemoveAt(pos);
			if(client->GetSessionUp() > 0){ //[Fix] -Failed Upload Session Count-, v0.29c (Maella)
				successfullupcount++;
				totaluploadtime += client->GetUpStartTimeDelay()/1000;
				if (client->Credits()) client->Credits()->ClearUploadQueueWaitTime(); // Moonlight: SUQWT
			}
			else {
				failedupcount++;
				if (client->Credits()) client->Credits()->SaveUploadQueueWaitTime(); // Moonlight: SUQWT
			}
			client->SetUploadState(US_NONE);
			client->ClearUploadBlockRequests();
			client->ClearSendHistory();
			if (client->addOnWaiting && !client->toRemoveNow && !client->toDelete)
				AddClientToQueue(client,true);
			else if (client->toRemoveNow)
				client->SetUploadFileID(NULL);
			client->toRemove=false;
			client->toRemoveNow=false;
			client->noBlocksToSend=false;
			client->lastToSend=0;
			client->addOnWaiting=false;
			if (client->socket) client->socket->SetPriorityReceive(false);
            //Pawcio: BC
			return true;
		}
	}
	return false;
}

bool CUploadQueue::RemoveFromReservedQueue(CUpDownClient* client, bool updatewindow){
	theApp.clientlist->AddTrackClient(client); // Keep track of this client
	for (POSITION pos = reserveduploadinglist.GetHeadPosition();pos != 0;reserveduploadinglist.GetNext(pos)){
		if (client == reserveduploadinglist.GetAt(pos)){
			//Pawcio: Parts Selector
			if (client->socket){
				CKnownFile* reqfile = theApp.sharedfiles->GetFileByID(client->GetUploadFileID());
				if (reqfile){
					CSafeMemFile data(16+16);
					data.Write(reqfile->GetFileHash(),16);
					if (reqfile->IsPartFile())
						((CPartFile*)reqfile)->WritePartStatus(&data, 0);	// SLUGFILLER: hideOS
					else if (!reqfile->HideOvershares(&data, 0)){	// SLUGFILLER: hideOS
						uint32 null = 0;
						data.Write(&null,3);
					}
					Packet* packet = new Packet(&data);
					packet->opcode = OP_FILESTATUS;
					theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
					client->socket->SendPacket(packet,true);
				}
			}
			//Pawcio: Parts Selector

			//Pawcio: BC
			if (client == feeding)
				feeding=NULL;
			if (client == priorityClient)
				priorityClient=NULL;
			if (reservedFeedingPos == pos){
				POSITION next=pos;
				reserveduploadinglist.GetNext(next);
				reservedFeedingPos=next;
			}
			if (updatewindow)
				theApp.emuledlg->transferwnd.reservedlistctrl.RemoveClient(uploadinglist.GetAt(pos));
			reserveduploadinglist.RemoveAt(pos);
			if (pos=prioritylist.Find(client))
				prioritylist.RemoveAt(pos);
			if(client->GetSessionUp() > 0){
				++successfullupcount;
				totaluploadtime += client->GetUpStartTimeDelay()/1000;
				if (client->Credits()) client->Credits()->ClearUploadQueueWaitTime(); // Moonlight: SUQWT
			}
			else{
				++failedupcount;
				if (client->Credits()) client->Credits()->SaveUploadQueueWaitTime(); // Moonlight: SUQWT
			}
			client->SetUploadState(US_NONE);
			client->ClearUploadBlockRequests();
			client->ClearSendHistory();
			if (client->addOnWaiting && !client->toRemoveNow && !client->toDelete)
				AddClientToQueue(client,true);
			else if (client->toRemoveNow)
				client->SetUploadFileID(NULL);
			client->toRemove=false;
			client->toRemoveNow=false;
			client->addOnWaiting=false;
			client->noBlocksToSend=false;
			client->lastToSend=0;
			if (client->socket) client->socket->SetPriorityReceive(false);
			theApp.emuledlg->transferwnd.UpdateListCount(1);
			return true;
            //Pawcio: BC
		}
	}
	return false;
}

uint32 CUploadQueue::GetAverageUpTime(){
	if( successfullupcount ){
		return totaluploadtime/successfullupcount;
	}
	return 0;
}

bool CUploadQueue::RemoveFromWaitingQueue(CUpDownClient* client, bool updatewindow){
	CSingleLock waitinglistLock(&waitinglistMutex, true);//Pawcio: BC
	POSITION pos = waitinglist.Find(client);
	if (pos){
		//Xman see OnUploadqueue
		CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)client->GetUploadFileID());
		if (reqfile)
			reqfile->statistic.RemoveOnUploadqueue();
		//Xman end

		waitinglist.RemoveAt(pos);
		if (updatewindow){
			theApp.emuledlg->transferwnd.queuelistctrl.RemoveClient(client);
			theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
		}
		if (client->Credits()) client->Credits()->SaveUploadQueueWaitTime(); // Moonlight: SUQWT
		return true;
	}
	return false;
}

void CUploadQueue::RemoveFromWaitingQueue(POSITION pos, bool updatewindow){	
	CSingleLock waitinglistLock(&waitinglistMutex, true);//Pawcio: BC
	CUpDownClient* todelete = waitinglist.GetAt(pos);
	
	//Xman see OnUploadqueue
	CKnownFile* reqfile=NULL;
	if (todelete->GetLastAction()==OP_STARTUPLOADREQ)
		reqfile = theApp.sharedfiles->GetFileByID((uchar*)todelete->GetUploadFileID());
	else
	{	reqfile = theApp.sharedfiles->GetFileByID((uchar*)todelete->GetOldUploadFileID());
		//AddDebugLogLine(false,"--->a client was removed from waitingqueue without OP_STARTUPLOADREQ");
	}
	if (reqfile)
		reqfile->statistic.RemoveOnUploadqueue();
	//Xman end
	
	waitinglist.RemoveAt(pos);
	if (updatewindow)
		theApp.emuledlg->transferwnd.queuelistctrl.RemoveClient(todelete);
	if (todelete->Credits()) todelete->Credits()->SaveUploadQueueWaitTime(); // Moonlight: SUQWT
	todelete->SetUploadState(US_NONE);
}

void CUploadQueue::UpdateMaxClientScore() {
	m_imaxscore=0;
	uint32 score;
	uint32 cur_rate;
	uint32 total_rate = 0;
	for(POSITION pos = waitinglist.GetHeadPosition(); pos != 0; ) {
		CUpDownClient* cur_client =	waitinglist.GetNext(pos);
		score = cur_client->GetScore(true, false);
		if(score > m_imaxscore )
			m_imaxscore=score;
		//Pawcio for enkeyDev -EDT-
		cur_rate = cur_client->GetScore(false, false, true);
		total_rate += (cur_rate >= 0x4FFFFFFF ? 0 : cur_rate); // ignore friend slot
		//Pawcio for enkeyDev -EDT-
	}
	theApp.m_edt.SetTotalRate(total_rate);
}

bool CUploadQueue::CheckForTimeOver(CUpDownClient* client, bool fullChunk){ //by Pawcio
	//For full chunk keep up to 90 minutes - gives about 2kB/s to get a chunk
	if( client->GetUpStartTimeDelay() > 3600000 && !fullChunk || client->GetUpStartTimeDelay() > 5400000){ // Try to keep the clients from downloading for ever.
		theApp.emuledlg->AddDebugLogLine(false, "%s: Upload session ended due to excessive time.", client->GetUserName());
		return true;
	}
	// For some reason, some clients can continue to download after a chunk size.
	// Are they redownloading the same chunk over and over????
	if( client->GetSessionUp() > 10485760 ){
		theApp.emuledlg->AddDebugLogLine(false, "%s: Upload session ended due to excessive transfered amount.", client->GetUserName());
		return true;
	}

	if (!fullChunk){

		// Cache current client score
		const uint32 score = client->GetScore(true, true);

		// Check if another client has a bigger score
		if(score < GetHighestScoreOnReserved()){
				theApp.emuledlg->AddDebugLogLine(false, "%s: Upload session ended due to score.", client->GetUserName());
				return true;
		}
		if (score<GetMaxClientScore()) {
				AddDebugLogLine(false, "%s: Upload session ended due to score.", client->GetUserName());
				return true;
		}
	}
	return false;
}

void CUploadQueue::DeleteAll(){
	CSingleLock waitinglistLock(&waitinglistMutex, true);//Pawcio: BC
	waitinglist.RemoveAll();
	uploadinglist.RemoveAll();
	reserveduploadinglist.RemoveAll();
}

uint16 CUploadQueue::GetWaitingPosition(CUpDownClient* client){
	if (!IsOnUploadQueue(client))
		return 0;
	
	//MORPH START - Moved & Changed by SiRoB, This is a better place
	//MORPH START - Added by IceCream, Anti-leecher feature
	if (client->IsLeecher())
		return GetRandRange(5,24); // nRank = 75;
	//MORPH END   - Added by IceCream, Anti-leecher feature
	//MORPH END   - Moved & Changed by SiRoB, This is a better place 
	
	uint16 rank = 1;
	uint32 myscore = client->GetScore(false);
	CSingleLock waitinglistLock(&waitinglistMutex, true); //Pawcio: BC
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		if (waitinglist.GetAt(pos)->GetScore(false) > myscore)
			rank++;
	}
	return rank;
}

void CUploadQueue::CompUpDatarateOverhead(){
	// Patch by BadWolf - Accurate datarate Calculation
	TransferredData newitem = {m_nUpDataRateMSOverhead,::GetTickCount()};
	this->m_AvarageUDRO_list.AddTail(newitem);
	sumavgUDRO += m_nUpDataRateMSOverhead;
	while ((float)(m_AvarageUDRO_list.GetTail().timestamp - m_AvarageUDRO_list.GetHead().timestamp)  > MAXAVERAGETIME)
		sumavgUDRO -= m_AvarageUDRO_list.RemoveHead().datalen;
	m_nUpDataRateMSOverhead = 0;
	if(m_AvarageUDRO_list.GetCount() > 3){
		DWORD dwDuration = m_AvarageUDRO_list.GetTail().timestamp - m_AvarageUDRO_list.GetHead().timestamp;
		if (dwDuration)
			m_nUpDatarateOverhead = 1000 * sumavgUDRO / dwDuration;
	}
	else
		m_nUpDatarateOverhead = 0;
	return;
	// END Patch by BadWolf	
}

//Pawcio: BC

CUpDownClient* CUploadQueue::GetNextClient(CUpDownClient* lastclient){
	//Pawcio: BC
	CSingleLock waitinglistLock(&waitinglistMutex, true);//Pawcio: BC
	bool empty=waitinglist.IsEmpty();
	if (empty)
		return 0;
	CUpDownClient* head=waitinglist.GetHead();
	if (!lastclient)
		return head;
	POSITION pos = waitinglist.Find(lastclient);
	if (!pos){
		TRACE("Error: CServerList::GetNextClient");
		return head;
	}
	waitinglist.GetNext(pos);
	if (!pos)
		return NULL;
	CUpDownClient* client = waitinglist.GetAt(pos);
	return client;
}

void CUploadQueue::FindSourcesForFileById(CTypedPtrList<CPtrList, CUpDownClient*>* srclist, const uchar* filehash) {
	//Pawcio: BC
	POSITION pos;
	
	pos = uploadinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = uploadinglist.GetNext(pos);
		if(md4cmp(potential->GetUploadFileID(), filehash) == 0)
			srclist->AddTail(potential);
	}

	pos = reserveduploadinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = reserveduploadinglist.GetNext(pos);
		if(md4cmp(potential->GetUploadFileID(), filehash) == 0)
			srclist->AddTail(potential);
	}

	CSingleLock waitinglistLock(&waitinglistMutex, true); //Pawcio: BC
	pos = waitinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = waitinglist.GetNext(pos);
		if(md4cmp(potential->GetUploadFileID(), filehash) == 0)
			srclist->AddTail(potential);
	}
}

// Pawcio: BC
uint16 CUploadQueue::SlotsInRange(bool lowID)
{
	uint32 sendPerClient = UPLOAD_CLIENT_DATARATE + MaxUpload/250;

	if( sendPerClient > 4000 )
		sendPerClient = 4000;
	uint16 retVal;
	if (uploadinglist.GetCount() + reserveduploadinglist.GetCount() < (retVal = 2))
		return retVal;
	/*uint16 additionalSlots = 1;
	if (MaxUpload > 8000)
		additionalSlots = log10f(MaxUpload/1000.0f)/0.301f - 1;*/
	if (uploadinglist.GetCount() + reserveduploadinglist.GetCount() < (retVal = (uint16)(MaxUpload/sendPerClient) + /*additionalSlots +*/ (uint16)lowID))
		return retVal;
	return 0;
}

uint16 CUploadQueue::MaxSlots(bool lowID){
	uint32 maxCurrRate = (uint32)theApp.BC->GetMaxDataRate() * 1024;
	uint32 maxSendPerClient = UPLOAD_CLIENT_DATARATE + maxCurrRate/250;
	if (maxSendPerClient > 4000)
		maxSendPerClient = 4000;
	uint16 retVal = (uint16)(maxCurrRate / maxSendPerClient) + (uint16)lowID;
	if (retVal < 2)
		retVal = 2;
	return retVal;
}


UINT CUploadQueue::LoadingParts(LPVOID pParam){
	uint32 start,end;
	CUploadQueue* queue=(CUploadQueue*) pParam;
	queue->endLoadingParts = new CEvent();
	CTypedPtrList<CPtrList, CUpDownClient*> internalwithoutpart;
	while(theApp.emuledlg->IsRunning()){
		start=::GetTickCount();
		CSingleLock withoutpartlock(&queue->withoutpartMutex, true);//Pawcio: BC
		while (queue->withoutpart.GetHeadPosition())
			internalwithoutpart.AddTail(queue->withoutpart.RemoveHead());
		withoutpartlock.Unlock();
		while (internalwithoutpart.GetCount()){
			CUpDownClient* toLoadPart=internalwithoutpart.RemoveHead();
			toLoadPart->CreateNextBlockPackage();
			toLoadPart->waitingforparts=false;
		}
		end=::GetTickCount();
		if (end-start<100) ::Sleep(100-(end-start));
	}
	queue->endLoadingParts->SetEvent();
	return 0;
}

void CUploadQueue::AddToBlockedQueue(CEMSocket* const & sock){
	sock->SetOnBlockedControlQueue(true);
	blockedSockets.AddTail(sock);
}


void CUploadQueue::AddToControlQueue(CEMSocket* const & sock){
	sock->SetOnUpControlQueue(true);
	EMSockControlQueue.AddTail(sock);
}
/*void    CUploadQueue::RemoveFromBlockedSockets(CEMSocket* const & sock){
	POSITION pos;
	if (pos=blockedSockets.Find(sock))
		blockedSockets.RemoveAt(pos);
}
void	CUploadQueue::RemoveFromEMSockQueue(CEMSocket* const & sock){
	POSITION pos;
	if (pos=EMSockControlQueue.Find(sock))
		EMSockControlQueue.RemoveAt(pos);
}*/
void	CUploadQueue::DecreaseToSend(const int& bytes){
	toSend-=bytes;
}

//Pawcio: BC
